/*
    project: Lamer Teris
    file:    field.H
    write:   PRP
    licence: Public Domain
    date:    8-10-2018
    editor:  VSCode
*/

#include <SDL2/SDL.h>
#include <stdio.h>
#include "shape.h"

#define NFIGURE 7
#define NELEMENT 4
#define WHITE 0

typedef struct _FIELD{
    SDL_Surface *element[4];
    int color;
}FIELD;

class Field : public Shape {

    public:
        Field();
        SDL_Surface * get(int n_figure, int n_element);
        int getColor(int n_figure);
        bool checkEdgeLeft(SDL_Surface *f, int x_field);
        bool checkEdgeRight(SDL_Surface *f, int x_field);
		bool checkEdgeRotate(SDL_Surface *f, int x_field);

    private:
        FIELD field[NFIGURE];
        void set(int n_figure, int n_element, int color);
        void draw(int n_figure, int n_element,int color, int x, int y);

};

class Szlam : public Shape {
    public:
        Szlam();
        bool addBottom(SDL_Surface *s, int n_figure, int n_element, int color, int posX, int posY);
        SDL_Surface * get();
        void draw();
        bool collisionBottom(SDL_Surface *s, int n_element, int figure, int x_s, int y_s, int color);
        bool collisionLeft(SDL_Surface *s, int n_element, int figure, int x_s, int y_s, int color, int *bottom);
        bool collisionRight(SDL_Surface *s, int n_element, int figure, int x_s, int y_s, int color, int *bottom);
        bool collisionRotate(SDL_Surface *s, int n_element, int figure, int x_s, int y_s, int color, int *bottom);
        int evenSurface(int *height);
        void cutSurface(int n, int h);
        bool highFull();
        void reset();

    private:
        SDL_Surface *field;

};

SDL_Rect set_rect(int x, int y, int w, int h);
//SDL_Surface * bg();
Uint32 getpixel(SDL_Surface *surface, int x, int y);
